package com.afp.ordermanagement.exception;

import javax.validation.ConstraintViolation;
import javax.validation.Validation;
import javax.validation.Validator;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class InvalidEntityResponse extends ErrorResponse {
    public List<Map<String, String>> fieldErrors;
    public InvalidEntityResponse(Integer status, String path, String type, String message, Object entity) {
        super(status, path, type, message);
        this.fieldErrors = InvalidEntityResponse.parseViolations(entity);
    }

    public static boolean isEntityValid(Object entity) {
        return validator.validate(entity).isEmpty();
    }

    static private final Validator validator = Validation.buildDefaultValidatorFactory().getValidator();
    static private  List<Map<String, String>> parseViolations(Object entity) {
        List<Map<String, String>> fieldErrors = new ArrayList<>();
        for (ConstraintViolation<Object> cv : validator.validate(entity)) {
            Map<String, String> errorMap = new HashMap<String, String>() {{
                put("field", cv.getPropertyPath().toString());
                put("message", cv.getMessage());
            }};
            fieldErrors.add(errorMap);
        }
        return fieldErrors;
    }
}
