package com.afp.ordermanagement.model;

import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.URL;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.index.Indexed;
import org.springframework.data.mongodb.core.mapping.Document;

import javax.validation.constraints.*;

@Data
@NoArgsConstructor
@Document(collection = "managers")
public class Manager {
    @Id
    private String id;

    @Size(min = 1, max = 250)
    @NotNull()
    private String firstName, lastName;

    @Indexed(unique = true)
    @Email
    private String email;

    @Size(min = 21, max = 21)
    @NotNull()
    private String googleId;

    @URL
    private String imageUrl;
}
