package com.afp.ordermanagement.model;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.Document;

import java.util.List;
import java.util.Objects;

@Data
@AllArgsConstructor
@Document(collection = "orders")
public class Order {

    @Id
    private String id;

    private String orderTrackingCode;

    private OrderStatus orderStatus;
    private long orderCreatedAt;
    private long orderUpdatedAt;

    private String customerId;
    private String customerEmailAddress;

    private List<Item> orderItems;
    private CustomerAddress customerAddress;

    public Order(){
    }

}
