package com.afp.ordermanagement.reactivekafkaservice;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.context.event.ApplicationStartedEvent;
import org.springframework.context.event.EventListener;
import org.springframework.stereotype.Service;
import reactor.kafka.receiver.KafkaReceiver;

@Service
@Slf4j
public class Receiver {

    @Autowired
    private KafkaReceiver<String, String> kafkaReceiver;

    @EventListener(ApplicationStartedEvent.class)
    public void consumeOrderStatus() {
        kafkaReceiver.receive()
                .doOnNext(record -> log.info(String.format("##### -> Receiver receiving message: %s ", record.value())))
                .doOnError(throwable -> System.out.println(throwable.getMessage()))
                .subscribe();
    }
}
